| D++ (DPP) C++ Discord API Bot Library

Search
Loading...
Searching...
No Matches
dpp::detail::coroutine::promise_t< R > Struct Template Reference

Promise type for coroutine. More...

`#include <coroutine.h>`

Inheritance diagram for dpp::detail::coroutine::promise_t< R >:
[legend]
Collaboration diagram for dpp::detail::coroutine::promise_t< R >:
[legend]

## Public Member Functions

final_awaiter< R > | final_suspend () const noexcept
| Function called by the standard library when reaching the end of a coroutine.
dpp::coroutine< R > | get_return_object ()
| Function called to get the coroutine object.
std_coroutine::suspend_always | initial_suspend () const noexcept
| Function called by the standard library when the coroutine start.
void | return_value (const R &expr) noexcept(std::is_nothrow_copy_constructible_v< R >)
| Function called by the standard library when the coroutine co_returns a value.
void | return_value (R &&expr) noexcept(std::is_nothrow_move_constructible_v< R >)
| Function called by the standard library when the coroutine co_returns a value.
template<typename T> requires (!std::is_same_v<R, std::remove_cvref_t<T>> && std::convertible_to<T, R>)
void | return_value (T &&expr) noexcept(std::is_nothrow_convertible_v< T, R >)
| Function called by the standard library when the coroutine co_returns a value.
void | unhandled_exception () noexcept
| Function called when an exception escapes the coroutine.

## Public Attributes

std::exception_ptr | exception {nullptr}
| Pointer to an uncaught exception thrown by the coroutine.
std_coroutine::coroutine_handle | parent {nullptr}
| Handle of the coroutine co_await-ing this coroutine.
std::optional< R > | result {}
| Return value of the coroutine.

## Detailed Description

template<typename R>
struct dpp::detail::coroutine::promise_t< R >

Promise type for coroutine.

## Member Function Documentation

## ◆ final_suspend()

template<typename R>

final_awaiter< R > dpp::detail::coroutine::promise_t< R >::final_suspend | ( |  | ) | const

nodiscard noexcept

Function called by the standard library when reaching the end of a coroutine.

Returns
  final_awaiter<R> Resumes any coroutine co_await-ing on this

## ◆ get_return_object()

template<typename R>

dpp::coroutine< R > dpp::detail::coroutine::promise_t< R >::get_return_object | ( |  | ) |

inline

Function called to get the coroutine object.

## ◆ initial_suspend()

template<typename R>

std_coroutine::suspend_always dpp::detail::coroutine::promise_t< R >::initial_suspend | ( |  | ) | const

inline nodiscard noexcept

Function called by the standard library when the coroutine start.

Returns
  std::suspend_always Always suspend at the start, for a lazy start

## ◆ return_value() [1/3]

template<typename R>

void dpp::detail::coroutine::promise_t< R >::return_value | ( | const R & | expr | ) |

inline noexcept

Function called by the standard library when the coroutine co_returns a value.

Stores the value internally to hand to the caller when it resumes.

Parameters

  expr | The value given to co_return

## ◆ return_value() [2/3]

template<typename R>

void dpp::detail::coroutine::promise_t< R >::return_value | ( | R && | expr | ) |

inline noexcept

Function called by the standard library when the coroutine co_returns a value.

Stores the value internally to hand to the caller when it resumes.

Parameters

  expr | The value given to co_return

## ◆ return_value() [3/3]

template<typename R>
template<typename T>
requires (!std::is_same_v<R, std::remove_cvref_t<T>> && std::convertible_to<T, R>)

void dpp::detail::coroutine::promise_t< R >::return_value | ( | T && | expr | ) |

inline noexcept

Function called by the standard library when the coroutine co_returns a value.

Stores the value internally to hand to the caller when it resumes.

Parameters

  expr | The value given to co_return

## ◆ unhandled_exception()

template<typename R>

void dpp::detail::coroutine::promise_t< R >::unhandled_exception | ( |  | ) |

inline noexcept

Function called when an exception escapes the coroutine.

Stores the exception to throw to the co_await-er

## Member Data Documentation

## ◆ exception

template<typename R>

std::exception_ptr dpp::detail::coroutine::promise_t< R >::exception {nullptr}

Pointer to an uncaught exception thrown by the coroutine.

## ◆ parent

template<typename R>

std_coroutine::coroutine_handle dpp::detail::coroutine::promise_t< R >::parent {nullptr}

Handle of the coroutine co_await-ing this coroutine.

## ◆ result

template<typename R>

std::optional<R> dpp::detail::coroutine::promise_t< R >::result {}

Return value of the coroutine.

D++ Library version 9.0.13 D++ Library version 9.0.12 D++ Library version 9.0.11 D++ Library version 9.0.10 D++ Library version 9.0.9 D++ Library version 9.0.8 D++ Library version 9.0.7 D++ Library version 9.0.6 D++ Library version 9.0.5 D++ Library version 9.0.4 D++ Library version 9.0.3 D++ Library version 9.0.2 D++ Library version 9.0.1 D++ Library version 9.0.0 D++ Library version 1.0.2 D++ Library version 1.0.1 D++ Library version 1.0.0